package com.mycompany.modularprey;

import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Item;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.NavPoint;
import cz.cuni.amis.utils.collections.MyCollections;

/**
 * Action that causes bot to run around the map looking for medkits.
 * @author Honza
 */
@PrimitiveInfo(name = "runAroundMap", description = "Run around the map trying to get spawned medkits and health vials")
public class RunAroundMap extends StateAction<PreyContext, Boolean> {

    public RunAroundMap(PreyContext ctx) {
        super("runAroundMap", ctx);
    }

    @Override
    public void init(VariableContext params) {
        
    }

    @Override
    public Boolean run(VariableContext params) {
        //if (true) return true;
        
        
        if (ctx.getPathExecutor().isExecuting()) {
                       
        } else {
            ctx.targetNav = MyCollections.getRandom(ctx.getWorld().getAll(NavPoint.class).values());
            ctx.getPathExecutor().followPath(ctx.getFwMap().computePath(ctx.getInfo().getNearestNavPoint(),ctx.targetNav));                    
        }
        /*
        if (ctx.targetNav != null) {
           if (ctx.targetNav.getLocation().getDistance(ctx.getInfo().getLocation()) <= 100) {
                ctx.targetNav = MyCollections.getRandom(ctx.getWorld().getAll(NavPoint.class).values());                        
           } 
           
           ctx.getNavigation().navigate(ctx.targetNav);
        } else {
           ctx.targetNav = MyCollections.getRandom(ctx.getWorld().getAll(NavPoint.class).values());                        
        }*/
        return true;
    }

    @Override
    public void done(VariableContext params) {
    	// We should normally stop navigation here, but we can be interrupted only by "hit-wall" drive
    	// that will cause the bot to JUMP and it will then return here anyway...
    	
    	// Moreover stopping navigation might filter out unreachable spots...
        ctx.getPathExecutor().stop();//.getNavigation().stopNavigation();
    }
}
